Get usage information Generally available

GET /_xpack/usage

Get information about the features that are currently enabled and available under the current license. The API also provides some usage statistics.

Required authorization

  • Cluster privileges: monitor

Query parameters

  • master_timeout string

    The period to wait for a connection to the master node. If no response is received before the timeout expires, the request fails and returns an error. To indicate that the request should never timeout, set it to -1.

    External documentation

Responses

  • 200 application/json
    Hide response attributes Show response attributes object
    • aggregate_metric object Required
      Hide aggregate_metric attributes Show aggregate_metric attributes object
      • available boolean Required
      • enabled boolean Required
    • analytics object Required
      Hide analytics attributes Show analytics attributes object
      • available boolean Required
      • enabled boolean Required
      • stats object
    • archive object Required Generally available; Added in 8.2.0
      Hide archive attributes Show archive attributes object
      • available boolean Required
      • enabled boolean Required
      • indices_count number Required
    • watcher object Required
      Hide watcher attributes Show watcher attributes object
      • available boolean Required
      • enabled boolean Required
      • execution object
      • watch object
      • count object Additional properties
    • ccr object Required
      Hide ccr attributes Show ccr attributes object
      • available boolean Required
      • enabled boolean Required
      • auto_follow_patterns_count number Required
      • follower_indices_count number Required
    • data_frame object
      Hide data_frame attributes Show data_frame attributes object
      • available boolean Required
      • enabled boolean Required
    • data_science object
      Hide data_science attributes Show data_science attributes object
      • available boolean Required
      • enabled boolean Required
    • data_streams object
      Hide data_streams attributes Show data_streams attributes object
      • available boolean Required
      • enabled boolean Required
      • data_streams number Required
      • indices_count number Required
    • data_tiers object Required
      Hide data_tiers attributes Show data_tiers attributes object
      • available boolean Required
      • enabled boolean Required
      • data_warm object
      • data_frozen object
      • data_cold object
      • data_content object
      • data_hot object
    • enrich object
      Hide enrich attributes Show enrich attributes object
      • available boolean Required
      • enabled boolean Required
    • eql object Required
      Hide eql attributes Show eql attributes object
      • available boolean Required
      • enabled boolean Required
      • features object
      • queries object Required
        Hide queries attribute Show queries attribute object
        • * object Additional properties
    • flattened object
      Hide flattened attributes Show flattened attributes object
      • available boolean Required
      • enabled boolean Required
      • field_count number Required
    • graph object Required
      Hide graph attributes Show graph attributes object
      • available boolean Required
      • enabled boolean Required
    • gpu_vector_indexing object Generally available; Added in 9.3.2

      GPU vector indexing usage statistics.

      Hide gpu_vector_indexing attributes Show gpu_vector_indexing attributes object
      • available boolean Required
      • enabled boolean Required
      • index_build_count number Required

        Total GPU index builds across the cluster.

      • nodes_with_gpu number Required

        Count of data nodes with GPU support.

      • nodes array[object] Required

        Per-node GPU details including type, memory, enabled status, and build count.

        Per-node GPU statistics for vector indexing.

        Per-node GPU statistics for vector indexing.

    • health_api object
      Hide health_api attributes Show health_api attributes object
      • available boolean Required
      • enabled boolean Required
      • invocations object
    • ilm object Required
      Hide ilm attributes Show ilm attributes object
      • policy_count number Required
      • policy_stats array[object] Required
        Hide policy_stats attributes Show policy_stats attributes object
        • indices_managed number Required
        • phases
    • logstash object Required
      Hide logstash attributes Show logstash attributes object
      • available boolean Required
      • enabled boolean Required
    • ml object Required
      Hide ml attributes Show ml attributes object
      • available boolean Required
      • enabled boolean Required
      • datafeeds object Required
        Hide datafeeds attribute Show datafeeds attribute object
        • * object Additional properties
      • jobs object Required

        Job usage statistics. The _all entry is always present and gathers statistics for all jobs.

        Hide jobs attribute Show jobs attribute object
        • * object Additional properties
      • node_count number Required
      • data_frame_analytics_jobs object
      • inference object
    • monitoring object Required
      Hide monitoring attributes Show monitoring attributes object
      • available boolean Required
      • enabled boolean Required
      • collection_enabled boolean Required
      • enabled_exporters object Required
        Hide enabled_exporters attribute Show enabled_exporters attribute object
        • * number Additional properties
    • rollup object Required
      Hide rollup attributes Show rollup attributes object
      • available boolean Required
      • enabled boolean Required
    • runtime_fields object
      Hide runtime_fields attributes Show runtime_fields attributes object
      • available boolean Required
      • enabled boolean Required
      • field_types array[object] Required
    • spatial object Required
      Hide spatial attributes Show spatial attributes object
      • available boolean Required
      • enabled boolean Required
    • searchable_snapshots object Required
      Hide searchable_snapshots attributes Show searchable_snapshots attributes object
      • available boolean Required
      • enabled boolean Required
      • indices_count number Required
      • full_copy_indices_count number
      • shared_cache_indices_count number
    • security object Required
      Hide security attributes Show security attributes object
      • available boolean Required
      • enabled boolean Required
      • api_key_service object
      • anonymous object
      • fips_140 object
      • ipfilter object
      • realms object Required
      • role_mapping object Required
        Hide role_mapping attribute Show role_mapping attribute object
        • * object Additional properties
      • roles object
      • ssl object
      • system_key object
      • token_service object
      • operator_privileges object
    • slm object Required
      Hide slm attributes Show slm attributes object
      • available boolean Required
      • enabled boolean Required
      • policy_count number
      • policy_stats object
    • sql object Required
      Hide sql attributes Show sql attributes object
      • available boolean Required
      • enabled boolean Required
      • features object Required
        Hide features attribute Show features attribute object
        • * number Additional properties
      • queries object Required
        Hide queries attribute Show queries attribute object
        • * object Additional properties
    • transform object Required
      Hide transform attributes Show transform attributes object
      • available boolean Required
      • enabled boolean Required
    • vectors object
      Hide vectors attributes Show vectors attributes object
      • available boolean Required
      • enabled boolean Required
      • dense_vector_dims_avg_count number Required
      • dense_vector_fields_count number Required
      • sparse_vector_fields_count number
    • voting_only object Required
      Hide voting_only attributes Show voting_only attributes object
      • available boolean Required
      • enabled boolean Required
GET /_xpack/usage
GET /_xpack/usage
resp = client.xpack.usage()
const response = await client.xpack.usage();
response = client.xpack.usage
$resp = $client->xpack()->usage();
curl -X GET -H "Authorization: ApiKey $ELASTIC_API_KEY" "$ELASTICSEARCH_URL/_xpack/usage"
client.xpack().usage(u -> u);
Response examples (200)
An abbreviated response from `GET /_xpack/usage`.
{
  "security" : {
    "available" : true,
    "enabled" : true
  },
  "monitoring" : {
    "available" : true,
    "enabled" : true,
    "collection_enabled" : false,
    "enabled_exporters" : {
      "local" : 1
    }
  },
  "watcher" : {
      "available" : true,
      "enabled" : true,
      "execution" : {
        "actions" : {
          "_all" : {
            "total" : 0,
            "total_time_in_ms" : 0
          }
        }
      },
    "watch" : {
      "input" : {
        "_all" : {
          "total" : 0,
          "active" : 0
        }
      },
      "trigger" : {
        "_all" : {
          "total" : 0,
          "active" : 0
        }
      }
    },
    "count" : {
      "total" : 0,
      "active" : 0
    }
  },
  "graph" : {
    "available" : true,
    "enabled" : true
  },
  "ml" : {
    "available" : true,
    "enabled" : true,
    "jobs" : {
      "_all" : {
        "count" : 0,
        "detectors" : { },
        "created_by" : { },
        "model_size" : { },
        "forecasts" : {
          "total" : 0,
          "forecasted_jobs" : 0
        }
      }
    },
    "datafeeds" : {
      "_all" : {
        "count" : 0
      }
    },
    "data_frame_analytics_jobs" : {
      "_all" : {
        "count" : 0
      },
      "analysis_counts": { },
      "memory_usage": {
        "peak_usage_bytes": {
          "min": 0.0,
          "max": 0.0,
          "avg": 0.0,
          "total": 0.0
        }
      }
    },
    "inference" : {
      "ingest_processors" : {
        "_all" : {
          "num_docs_processed" : {
            "max" : 0,
            "sum" : 0,
            "min" : 0
          },
          "pipelines" : {
            "count" : 0
          },
          "num_failures" : {
            "max" : 0,
            "sum" : 0,
            "min" : 0
          },
          "time_ms" : {
            "max" : 0,
            "sum" : 0,
            "min" : 0
          }
        }
      },
      "trained_models" : {
        "_all" : {
          "count": 1
        },
        "count": {
          "total": 1,
          "prepackaged": 1,
          "other": 0
        },
        "model_size_bytes": {
          "min": 0.0,
          "max": 0.0,
          "avg": 0.0,
          "total": 0.0
        },
        "estimated_operations": {
          "min": 0.0,
          "max": 0.0,
          "avg": 0.0,
          "total": 0.0
        }
      },
      "deployments": {
        "count": 0,
        "inference_counts": {
          "total": 0.0,
          "min": 0.0,
          "avg": 0.0,
          "max": 0.0
        },
        "stats_by_model": [],
        "model_sizes_bytes": {
          "total": 0.0,
          "min": 0.0,
          "avg": 0.0,
          "max": 0.0
        },
        "time_ms": {
          "avg": 0.0
        }
      }
    },
    "node_count" : 1,
    "memory": {
      anomaly_detectors_memory_bytes: 0,
      data_frame_analytics_memory_bytes: 0,
      pytorch_inference_memory_bytes: 0,
      total_used_memory_bytes: 0
    }
  },
  "inference": {
    "available" : true,
    "enabled" : true,
    "models" : [ ]
  },
  "logstash" : {
    "available" : true,
    "enabled" : true
  },
  "eql" : {
    "available" : true,
    "enabled" : true
  },
  "esql" : {
    "available" : true,
    "enabled" : true,
    "features" : {
      "eval" : 0,
      "stats" : 0,
      "dissect": 0,
      "grok" : 0,
      "limit" : 0,
      "where" : 0,
      "sort" : 0,
      "drop" : 0,
      "show" : 0,
      "rename" : 0,
      "mv_expand" : 0,
      "keep" : 0,
      "enrich" : 0,
      "from" : 0,
      "row" : 0
    },
    "queries" : {
      "rest" : {
        "total" : 0,
        "failed" : 0
      },
      "kibana" : {
        "total" : 0,
        "failed" : 0
      },
      "_all" : {
        "total" : 0,
        "failed" : 0
    }
  }
  },
  "sql" : {
    "available" : true,
    "enabled" : true,
    "features" : {
      "having" : 0,
      "subselect" : 0,
      "limit" : 0,
      "orderby" : 0,
      "where" : 0,
      "join" : 0,
      "groupby" : 0,
      "command" : 0,
      "local" : 0
    },
    "queries" : {
      "rest" : {
        "total" : 0,
        "paging" : 0,
        "failed" : 0
      },
      "cli" : {
        "total" : 0,
        "paging" : 0,
        "failed" : 0
      },
      "canvas" : {
        "total" : 0,
        "paging" : 0,
        "failed" : 0
      },
      "odbc" : {
        "total" : 0,
        "paging" : 0,
        "failed" : 0
      },
      "jdbc" : {
        "total" : 0,
        "paging" : 0,
        "failed" : 0
      },
      "odbc32" : {
        "total" : 0,
        "paging" : 0,
        "failed" : 0
      },
      "odbc64" : {
        "total" : 0,
        "paging" : 0,
        "failed" : 0
      },
      "_all" : {
        "total" : 0,
        "paging" : 0,
        "failed" : 0
      },
      "translate" : {
        "count" : 0
      }
    }
  },
  "rollup" : {
    "available" : true,
    "enabled" : true
  },
  "ilm" : {
    "policy_count" : 3,
    "policy_stats" : [ ]
  },
  "slm" : {
    "available" : true,
    "enabled" : true
  },
  "ccr" : {
    "available" : true,
    "enabled" : true,
    "follower_indices_count" : 0,
    "auto_follow_patterns_count" : 0
  },
  "transform" : {
    "available" : true,
    "enabled" : true
  },
  "voting_only" : {
    "available" : true,
    "enabled" : true
  },
  "searchable_snapshots" : {
    "available" : true,
    "enabled" : true,
    "indices_count" : 0,
    "full_copy_indices_count" : 0,
    "shared_cache_indices_count" : 0
  },
  "spatial" : {
    "available" : true,
    "enabled" : true
  },
  "analytics" : {
    "available" : true,
    "enabled" : true,
    "stats": {
      "boxplot_usage" : 0,
      "top_metrics_usage" : 0,
      "normalize_usage" : 0,
      "cumulative_cardinality_usage" : 0,
      "t_test_usage" : 0,
      "rate_usage" : 0,
      "string_stats_usage" : 0,
      "moving_percentiles_usage" : 0,
      "multi_terms_usage" : 0
    }
  },
  "data_streams" : {
    "available" : true,
    "enabled" : true,
    "data_streams" : 0,
    "indices_count" : 0
  },
  "data_lifecycle" : {
    "available": true,
    "enabled": true,
    "count": 0,
    "default_rollover_used": true,
    "data_retention": {
      "configured_data_streams": 0
    },
    "effective_retention": {
      "retained_data_streams": 0
    },
    "global_retention": {
      "default": {
        "defined": false
      },
      "max": {
        "defined": false
      }
    }
  },
  "data_tiers" : {
    "available" : true,
    "enabled" : true,
    "data_warm" : {
      "node_count" : 0,
      "index_count" : 0,
      "total_shard_count" : 0,
      "primary_shard_count" : 0,
      "doc_count" : 0,
      "total_size_bytes" : 0,
      "primary_size_bytes" : 0,
      "primary_shard_size_avg_bytes" : 0,
      "primary_shard_size_median_bytes" : 0,
      "primary_shard_size_mad_bytes" : 0
    },
    "data_frozen" : {
      "node_count" : 1,
      "index_count" : 0,
      "total_shard_count" : 0,
      "primary_shard_count" : 0,
      "doc_count" : 0,
      "total_size_bytes" : 0,
      "primary_size_bytes" : 0,
      "primary_shard_size_avg_bytes" : 0,
      "primary_shard_size_median_bytes" : 0,
      "primary_shard_size_mad_bytes" : 0
    },
    "data_cold" : {
      "node_count" : 0,
      "index_count" : 0,
      "total_shard_count" : 0,
      "primary_shard_count" : 0,
      "doc_count" : 0,
      "total_size_bytes" : 0,
      "primary_size_bytes" : 0,
      "primary_shard_size_avg_bytes" : 0,
      "primary_shard_size_median_bytes" : 0,
      "primary_shard_size_mad_bytes" : 0
    },
    "data_content" : {
      "node_count" : 0,
      "index_count" : 0,
      "total_shard_count" : 0,
      "primary_shard_count" : 0,
      "doc_count" : 0,
      "total_size_bytes" : 0,
      "primary_size_bytes" : 0,
      "primary_shard_size_avg_bytes" : 0,
      "primary_shard_size_median_bytes" : 0,
      "primary_shard_size_mad_bytes" : 0
    },
    "data_hot" : {
      "node_count" : 0,
      "index_count" : 0,
      "total_shard_count" : 0,
      "primary_shard_count" : 0,
      "doc_count" : 0,
      "total_size_bytes" : 0,
      "primary_size_bytes" : 0,
      "primary_shard_size_avg_bytes" : 0,
      "primary_shard_size_median_bytes" : 0,
      "primary_shard_size_mad_bytes" : 0
    }
  },
  "aggregate_metric" : {
    "available" : true,
    "enabled" : true
  },
  "archive" : {
    "available" : true,
    "enabled" : true,
    "indices_count" : 0
  },
  "health_api" : {
    "available" : true,
    "enabled" : true,
    "invocations": {
      "total": 0
    }
  },
  "remote_clusters": {
    "size": 0,
    "mode": {
      "proxy": 0,
      "sniff": 0
    },
    "security": {
      "cert": 0,
      "api_key": 0
    }
  },
  "enterprise_search" : {
    "available": true,
    "enabled": true,
    "search_applications" : {
      "count": 0
    },
    "analytics_collections": {
      "count": 0
    },
    "query_rulesets": {
      "total_rule_count": 0,
      "total_count": 0,
      "min_rule_count": 0,
      "max_rule_count": 0
    }
  },
  "universal_profiling" : {
    "available" : true,
    "enabled" : true
  },
  "logsdb": {
    "available": true,
    "enabled": false,
    "indices_count": 0,
    "indices_with_synthetic_source": 0,
    "num_docs": 0,
    "size_in_bytes": 0,
    "has_custom_cutoff_date": false
  }
}